package com.minemaarten.signals.block;

import net.minecraft.block.BlockRailPowered;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.item.EntityMinecart;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.Vec3d;
import net.minecraft.world.World;

import com.minemaarten.signals.client.CreativeTabSignals;
import com.minemaarten.signals.init.ModBlocks;

public class BlockLimiterRail extends BlockRailPowered{

    public BlockLimiterRail(){
        func_149663_c("limiter_rail");
        func_149647_a(CreativeTabSignals.getInstance());
        ModBlocks.registerBlock(this);
    }

    @Override
    public void onMinecartPass(World world, EntityMinecart cart, BlockPos pos){
        super.onMinecartPass(world, cart, pos);
        Vec3d vec = new Vec3d(cart.field_70159_w, cart.field_70181_x, cart.field_70179_y);
        double maxSpeed = 0.1D;
        double maxDeceleration = 0.2D;
        double vecLength = vec.func_72433_c();
        if(vecLength > maxSpeed) {
            IBlockState state = world.func_180495_p(pos); //Only retrieve the block state when we need to, as this is more expensive than a bit of vector math.
            if(!state.func_177229_b(field_176569_M)) {
                vecLength = Math.max(vecLength - maxDeceleration, maxSpeed);
                vec = vec.func_72432_b().func_186678_a(vecLength);
                cart.field_70159_w = vec.field_72450_a;
                cart.field_70181_x = vec.field_72448_b;
                cart.field_70179_y = vec.field_72449_c;
            }
        }
    }
}
