package com.minemaarten.signals.commands;

import java.util.List;

import net.minecraft.command.CommandBase;
import net.minecraft.command.CommandException;
import net.minecraft.command.ICommandSender;
import net.minecraft.command.WrongUsageException;
import net.minecraft.server.MinecraftServer;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.text.TextComponentTranslation;

import com.minemaarten.signals.rail.network.mc.RailNetworkManager;

public class CommandSignals extends CommandBase{

    @Override
    public String func_71517_b(){
        return "signals";
    }

    @Override
    public String func_71518_a(ICommandSender sender){
        return "signals <action> <arguments>";
    }

    @Override
    public void func_184881_a(MinecraftServer server, ICommandSender sender, String[] args) throws CommandException{
        if(args.length == 0) throw new WrongUsageException("command.signals.noArgs");
        String subCommand = args[0];
        if(subCommand.equals("rebuildNetwork")) {
            RailNetworkManager.getInstance().rebuildNetwork();
            sender.func_145747_a(new TextComponentTranslation("command.signals.networkCleared"));
        } else {
            throw new WrongUsageException("command.signals.invalidSubCommand", subCommand);
        }
    }

    @Override
    public List<String> func_184883_a(MinecraftServer server, ICommandSender sender, String[] args, BlockPos targetPos){
        return args.length == 1 ? func_71530_a(args, "rebuildNetwork") : super.func_184883_a(server, sender, args, targetPos);
    }
}
